<?php

/**
 * @package   HikaShop for Joomla!
 * @author    https://www.brainforge.co.uk
 * @copyright (C) 2020 Jonathan Brain. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class plgHikashopBfrelatedcategories extends JPlugin {

	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);

		JFactory::getLanguage()->load('plg_hikashop_bfrelatedcategories', __DIR__);
	}

	public function onFieldsLoad(&$fields, &$options)
	{
		$field = new stdClass();
		$field->name = 'bfrelatedcategories';
		$field->text = jText::_('PLG_HIKASHOPPAYMENT_BFRELATEDCATEGORIES_FIELD_TITLE');
		$field->options = array('columnname');
		$fields[] = $field;
	}

	public function initFieldClass()
	{
		require_once(__DIR__ . '/fields/categories.php');
	}

	public function onHikashopAfterDisplayView(&$view)
	{
		if (!JFactory::getApplication()->isClient('site'))
		{
			return;
		}

		if (@$view->module)
		{
			return;
		}

		switch(get_class($view))
		{
			case 'CategoryViewCategory':
				if (empty($view->element->category_related))
				{
					break;
				}
				$this->showRelatedCategories($view, $view->element->category_related);
				break;
			case 'ProductViewProduct':
				break;
		}
	}

	protected function showRelatedCategories($view, $relatedCategories)
	{
		$relatedCategories = trim(preg_replace('/[^0-9]+/', ',', $relatedCategories), ',');
		if (empty($relatedCategories)) return;

		$config = hikashop_config();
		$defaultImagePath = $config->get('default_image');

		if($defaultImagePath == 'barcode.png') {
			$defaultImagePath = HIKASHOP_MEDIA.'images'.DS.'barcode.png';
		}
		else
		{
			$uploadFolder = rtrim($config->get('uploadfolder', 'media/com_hikashop/upload/'), '/');
			$defaultImagePath = $uploadFolder . '/' . $defaultImagePath;
		}

		$layout = 'show_list_table';

		$overridePath = JPATH_THEMES . '/' . JFactory::getApplication()->getTemplate() .
			'/plg_hikashop_bfrelatedcategories/' . $layout . '.php';
		if (is_file($overridePath))
		{
			include($overridePath);
		}
		else
		{
			include(__DIR__ . '/tmpl/' . $layout . '.php');
		}
	}
}
