<?php

/**
 * @package   HikaShop for Joomla!
 * @author    https://www.brainforge.co.uk
 * @copyright (C) 2020 Jonathan Brain. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php

class hikashopFieldBfrelatedcategories extends hikashopFieldText {
	function __construct(&$obj) {
		parent::__construct($obj);
	}

	function check(&$field, &$value, $oldvalue) {
		$data = JFactory::getApplication()->input->get($field->field_namekey);
		if (is_array($data))
		{
			$value = trim(implode(',', $data), ' ,');
		}
		else {
			$value = '';
		}

		if (empty($value)) {
			$value = 'all';
		}
		return true;
	}

	function display($field, $value, $map, $inside, $options = '', $test = false, $allFields = null, $allValues = null) {
		$value = trim($value, ' ,');
		if($value == 'all') $value = '';

		$nameboxType = hikashop_get('type.namebox');
		return  $nameboxType->display(
			$field->field_namekey,
			preg_split('/[^0-9]+/', $value),
			hikashopNameboxType::NAMEBOX_MULTIPLE,
			'category',
			array(
				'delete' => true,
				'default_text' => '<em>'.JText::_('HIKA_NONE').'</em>',
			)
		);
	}

	function show(&$field, $value) {
		$value = trim($value, ' ,');
		if (empty($value) || $value == 'all') {
			return '';
		}

		$categoryClass = hikashop_get('class.category');
		$value = preg_split('/[^0-9]+/', $value);
		$names = $categoryClass->getCategories($value, 'category_name');

		$html = '';
		foreach($names as $name)
		{
			$html .= '<span class="plg_hikashop_bfrelatedcategory_name">' .
				$name->category_name .
				'<span class="plg_hikashop_bfrelatedcategory_separator">, </span>' .
				'</span>';
		}
		return $html;
	}
}
