<?php
/**
 * @package   HikaShop for Joomla!
 * @author    https://www.brainforge.co.uk
 * @copyright (C) 2020-2024 Jonathan Brain. All rights reserved.
 * @license   GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */

/** @var string $defaultImagePath */
/** @var array $relatedCategories */
/** @var object $view */

defined('_JEXEC') or die('Restricted access');

$html = array();
$col = 0;
foreach(explode(',', $relatedCategories) as $relatedCategory)
{
	$acl_filters = array();
	hikashop_addACLFilters($acl_filters, 'category_access');
	$acl_filters[] = 'category_published = 1';
	$acl_filters[] = "category_type='product'";
	$acl_filters[] = 'category_id = ' . $relatedCategory;

	$database = JFactory::getDBO();
	$query = 'SELECT * FROM #__hikashop_category WHERE ' . implode(' AND ', $acl_filters);
	$database->setQuery($query, 0, 1);
	$category = $database->loadObject();
	if (empty($category)) continue;

	if ($col++ == 3)
	{
		$html[] = '</tr><tr>';
		$col = 1;
	}

	$img = trim($category->category_altrelated_image ?? '');
	if (empty($img))
	{
		$query = 'SELECT file_id, file_path, file_name, file_description FROM #__hikashop_file ' .
			"WHERE file_type = 'category' " .
			'AND file_ref_id = ' . $category->category_id . ' ' .
			'ORDER BY file_ordering LIMIT 1';
		$database->setQuery($query);
		$file = $database->loadObject();

		if (!empty($file) && !empty($file->file_path))
		{
			$img = '<img src="' . $view->image->getPath($file->file_path) . '"' .
				' class="hikashop_category_listing_image bfrelatedcategories_image_' . $file->file_id . '"' .
				' title="' . $view->escape($file->file_description) . '"' .
				' alt="' . $view->escape($file->file_name) . '"/>';
		}
		else
		{
			$img = '<img src="' . $defaultImagePath . '"' .
				' class="hikashop_category_listing_image bfrelatedcategories_image_"' .
				' alt="Missing Image"/>';
		}
	}
	else
	{
		$img = '<img src="' . $img . '"' .
			' class="hikashop_category_listing_image bfrelatedcategories_image_alt"/>';
	}

	if (empty($category->category_canonical))
	{
		$url = $view->getLink($category->category_id);
	}
	else
	{
		$url = hikashop_cleanURL($category->category_canonical);
	}

	$html[] = '<td class="hikashop_category_image bfrelatedcategories_' . $category->category_id . '">' .
	'<div class="bfrelatedcategories">' .
		'<a href="' . $url . '">' .
			'<div class="hikashop_category_image">' . $img . '</div>' .
			'<div class="hikashop_category_name">' . htmlspecialchars($category->category_name) . '</div>' .
		'</a>' .
	'</div></td>';
}

if (!empty($html))
{
	while ($col++ < 3)
	{
		$html[] = '<td style="visibility: hidden">' . $col . '</td>';
	}

	echo '<div class="plg_hikashop_bfrelatedcategories bfrelatedcategories_' . $view->element->category_id . '">';
	echo '<h3>' . JText::sprintf('PLG_HIKASHOPPAYMENT_BFRELATEDCATEGORIES_TITLE', $view->element->category_name) . '</h3>';
	echo '<table><tr>' . implode('', $html) . '</tr></table>';
	echo '</div>';
}
